<!--
 * @Descripttion: (订单/tb_order 订单改价弹窗)
 * @version: (1.0)
 * @Author: (lwh)
 * @Date: (2023-09-04)
 * @LastEditors: (lwh)
 * @LastEditTime: (2023-09-04)
-->
<template>
  <el-dialog v-model="props.modelValue" title="订单改价" width="600px" @closed="closeDialog" @open="openDialog">
    <el-form ref="formRef" :model="formData" :rules="rules">
      <el-row :gutter="20">
        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="订单金额" prop="orderAmount">
            <el-input-number v-model.number="formData.orderAmount" controls-position="right" :min="0" :precision="2"/>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row :gutter="20">
        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="运费金额" prop="expressPrice">
            <el-input-number v-model.number="formData.expressPrice" controls-position="right" :min="0" :precision="2"/>
          </el-form-item>
        </el-col>
      </el-row>


    </el-form>

    <template #footer>
      <div class="dialog-footer">
        <el-button type="primary" @click="handleEditClick(formRef)" :loading="loadingStatus">确认</el-button>
        <el-button @click="handleResetClick(formRef)">重置</el-button>
      </div>
    </template>
  </el-dialog>
</template>

<script setup>
import { ElMessage } from 'element-plus'
import modal from '@/plugins/modal.js'
import { reactive, ref, watch } from "vue";
import { changePrice } from "@/api/business/OrderManage/Orders/order.js";


// 打开弹窗时回调
const openDialog = async () => {

}

const formData = ref({
  ...props.data,
});
watch(props, async (v) => {
  formData.value = v.data;

});

// 业务参数



// -业务方法



// -基础参数
const props = defineProps({
  modelValue: Boolean,
  data: Object,
  done: Function,
});

const loadingStatus = ref(false)
const labelWidth = 100;
const formRef = ref();
const { proxy } = getCurrentInstance()
const emits = defineEmits(["update:modelValue"]);
const imgData = ref({
  fileDir: "Order"
})

// 验证
const rules = reactive({
  orderAmount: [{ required: true, message: "订单金额不能为空", trigger: "blur" }],
  expressPrice: [{ required: true, message: "运费金额不能为空", trigger: "blur" }],
});

// -基础方法
// 提交
const handleEditClick = async (formEl) => {
  if (!formEl) return;
  formEl.validate(async (valid) => {
    if (!valid) {
      return;
    }
    loadingStatus.value = true


    const { code } = await changePrice(formData.value);
    if (code == 200) {
      modal.msgSuccess('金额修改成功')
      props.done();
      closeDialog();
      loadingStatus.value = false
    }
  });
}

const handleResetClick = async (formEl) => {
  if (!formEl) return;
  formEl.resetFields();
}
const closeDialog = () => {
  emits("update:modelValue", false);
};

</script>
